
#ifndef __CDLISTFILE_H_
#define __CDLISTFILE_H_

class CArtistList;

#pragma warning(disable: 4786)

/////////////////////////////////////////////////////////////////////////

class CCDListFileLine
{
public:
	CCDListFileLine(void);
	virtual ~CCDListFileLine(void);

	void SetLineBuffer(const char *buffer);
	void setArtistBuffer(const char *buffer);
	void setArtistShortBuffer(const char *buffer);
	void setTitleBuffer(const char *buffer);

	bool ParseBuffer(unsigned int previousNumber, const char *previousArtist);

	unsigned int GetNumber(void);
	const char *GetArtist(void);
	const char *GetArtistShort(void);
	const char *GetTitle(void);

protected:
	char *m_lineBuffer;
	char *m_artistBuffer;
	char *m_artistShortBuffer;
	char *m_titleBuffer;

	unsigned int m_number;
	const char *m_artist;
	const char *m_title;
};

/////////////////////////////////////////////////////////////////////////

class CCDListFile
{
public:
	CCDListFile(void);
	virtual ~CCDListFile(void);

	bool Read(FILE *pfInputList);
	bool Parse(void);
	bool MakeArtistList(CArtistList *pArtistList);

protected:
	list<CCDListFileLine *> m_lines;
};

/////////////////////////////////////////////////////////////////////////

#endif
