
#include "stdafx.h"

#include "Discography.h"
#include "PanelLines.h"
#include "CSFSection.h"

/////////////////////////////////////////////////////////////////////////

CPLBlank::CPLBlank(void)
{
}

CPLBlank::~CPLBlank(void)
{
}

void CPLBlank::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
}

/////////////////////////////////////////////////////////////////////////

CPLTwoArtists::CPLTwoArtists(const CArtist *pArtistOne, unsigned int artistOneDiscPanelNumber,
								const CArtist *pArtistTwo, unsigned int artistTwoDiscPanelNumber)
{
	m_pArtistOne = pArtistOne;
	m_pArtistTwo = pArtistTwo;
	m_artistOneDiscPanelNumber = artistOneDiscPanelNumber;
	m_artistTwoDiscPanelNumber = artistTwoDiscPanelNumber;
}

CPLTwoArtists::~CPLTwoArtists(void)
{
}

void CPLTwoArtists::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pArtistOne)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												0, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscLeftButton.bmp",
												CCSFSection::BUTTON_JUMPDISCPAGE,
												m_artistOneDiscPanelNumber);

		pPanelCSFSection->AddFrameSubSection(	m_pArtistOne->GetName(),
												36, ypos, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_WHITE,
												"BMP\\TwoDiscLeftStrip.bmp");
	}

	if (NULL != m_pArtistTwo)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												204, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscRightButton.bmp",
												CCSFSection::BUTTON_JUMPDISCPAGE,
												m_artistTwoDiscPanelNumber);

		pPanelCSFSection->AddFrameSubSection(	m_pArtistTwo->GetName(),
												36, ypos + 17, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscRightStrip.bmp");
	}
}

/////////////////////////////////////////////////////////////////////////

CPLOneArtistAndContinuation::CPLOneArtistAndContinuation(const CArtist *pArtistOne, unsigned int artistOneDiscPanelNumber,
															unsigned int continuationPanelNumber)
{
	m_pArtistOne = pArtistOne;
	m_artistOneDiscPanelNumber = artistOneDiscPanelNumber;
	m_continuationPanelNumber = continuationPanelNumber;
}

CPLOneArtistAndContinuation::~CPLOneArtistAndContinuation(void)
{
}

void CPLOneArtistAndContinuation::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pArtistOne)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												0, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscLeftButton.bmp",
												CCSFSection::BUTTON_JUMPDISCPAGE,
												m_artistOneDiscPanelNumber);

		pPanelCSFSection->AddFrameSubSection(	m_pArtistOne->GetName(),
												36, ypos, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_WHITE,
												"BMP\\TwoDiscLeftStrip.bmp");
	}

	if (0 != m_continuationPanelNumber)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												204, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscRightButton.bmp",
												CCSFSection::BUTTON_JUMPARTISTPAGE,
												m_continuationPanelNumber);

		pPanelCSFSection->AddFrameSubSection(	NULL,
												67, ypos + 17, 137, 17,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\ContinuationStrip.bmp");
	}
}

/////////////////////////////////////////////////////////////////////////

CPLArtistsLetterHeading::CPLArtistsLetterHeading(const char letter)
{
	m_letter = letter;
}

CPLArtistsLetterHeading::~CPLArtistsLetterHeading(void)
{
}

void CPLArtistsLetterHeading::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	char letterString[2];

	letterString[0] = m_letter;
	letterString[1] = '\0';

	pPanelCSFSection->AddButtonSubSection(	letterString,
											0, ypos, 240, 34,
											CCSFSection::FONT_10,
											CCSFSection::COLOUR_BLACK,
											"BMP\\ArtistHeader.bmp",
											CCSFSection::BUTTON_JUMPALPHABET,
											0);
}

/////////////////////////////////////////////////////////////////////////

CPLArtistsLetterContinuedHeading::CPLArtistsLetterContinuedHeading(const char letter, unsigned int previousLetterPanelNumber)
{
	m_letter = letter;
	m_previousLetterPanelNumber = previousLetterPanelNumber;
}

CPLArtistsLetterContinuedHeading::~CPLArtistsLetterContinuedHeading(void)
{
}

void CPLArtistsLetterContinuedHeading::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	char letterString[2];

	letterString[0] = m_letter;
	letterString[1] = '\0';

	pPanelCSFSection->AddButtonSubSection(	letterString,
											0, ypos, 240, 34,
											CCSFSection::FONT_10,
											CCSFSection::COLOUR_BLACK,
											"BMP\\ArtistContinuedHeader.bmp",
											CCSFSection::BUTTON_JUMPARTISTPAGE,
											m_previousLetterPanelNumber);
}

/////////////////////////////////////////////////////////////////////////

CPLArtistHeading::CPLArtistHeading(const CArtist *pArtist, unsigned int artistPanelNumber)
{
	m_pArtist = pArtist;
	m_artistPanelNumber = artistPanelNumber;
}

CPLArtistHeading::~CPLArtistHeading(void)
{
}

void CPLArtistHeading::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pArtist)
	{
		if ((0 == stricmp("Nine Inch Nails", m_pArtist->GetName()))
		||	(0 == stricmp("NIN",			 m_pArtist->GetName())))
		{
			pPanelCSFSection->AddButtonSubSection(	NULL,
													0, ypos, 240, 34,
													CCSFSection::FONT_0,
													CCSFSection::COLOUR_BLACK,
													"BMP\\ArtistHeader.bmp",
													CCSFSection::BUTTON_JUMPARTISTPAGE,
													m_artistPanelNumber);

			pPanelCSFSection->AddButtonSubSection(	NULL,
													92, ypos + 5, 57, 24,
													CCSFSection::FONT_0,
													CCSFSection::COLOUR_BLACK,
													"BMP\\NINClassicPronto.bmp",
													CCSFSection::BUTTON_JUMPARTISTPAGE,
													m_artistPanelNumber);
		}
		else
		{
			pPanelCSFSection->AddButtonSubSection(	m_pArtist->GetName(),
													0, ypos, 240, 34,
													CCSFSection::FONT_10,
													CCSFSection::COLOUR_BLACK,
													"BMP\\ArtistHeader.bmp",
													CCSFSection::BUTTON_JUMPARTISTPAGE,
													m_artistPanelNumber);
		}
	}
}


/////////////////////////////////////////////////////////////////////////

CPLArtistContinuedHeading::CPLArtistContinuedHeading(const CArtist *pArtist, unsigned int previousPanelNumber)
{
	m_pArtist = pArtist;
	m_previousPanelNumber = previousPanelNumber;
}

CPLArtistContinuedHeading::~CPLArtistContinuedHeading(void)
{
}

void CPLArtistContinuedHeading::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pArtist)
	{
		if ((0 == stricmp("Nine Inch Nails", m_pArtist->GetName()))
		||	(0 == stricmp("NIN",			 m_pArtist->GetName())))
		{
			pPanelCSFSection->AddButtonSubSection(	NULL,
													0, ypos, 240, 34,
													CCSFSection::FONT_0,
													CCSFSection::COLOUR_BLACK,
													"BMP\\ArtistContinuedHeader.bmp",
													CCSFSection::BUTTON_JUMPDISCPAGE,
													m_previousPanelNumber);

			pPanelCSFSection->AddButtonSubSection(	NULL,
													92, ypos + 5, 57, 24,
													CCSFSection::FONT_0,
													CCSFSection::COLOUR_BLACK,
													"BMP\\NINClassicPronto.bmp",
													CCSFSection::BUTTON_JUMPDISCPAGE,
													m_previousPanelNumber);
		}
		else
		{
			pPanelCSFSection->AddButtonSubSection(	m_pArtist->GetName(),
													0, ypos, 240, 34,
													CCSFSection::FONT_10,
													CCSFSection::COLOUR_BLACK,
													"BMP\\ArtistContinuedHeader.bmp",
													CCSFSection::BUTTON_JUMPDISCPAGE,
													m_previousPanelNumber);
		}
	}
}

/////////////////////////////////////////////////////////////////////////

CPLOneDiscAndContinuation::CPLOneDiscAndContinuation(const CDisc *pDiscOne, unsigned int continuationPanelNumber)
{
	m_pDiscOne = pDiscOne;
	m_continuationPanelNumber = continuationPanelNumber;
}

CPLOneDiscAndContinuation::~CPLOneDiscAndContinuation(void)
{
}

void CPLOneDiscAndContinuation::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pDiscOne)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												0, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscLeftButton.bmp",
												CCSFSection::BUTTON_PLAYDISC,
												m_pDiscOne->GetNum());

		pPanelCSFSection->AddFrameSubSection(	m_pDiscOne->GetTitle(),
												36, ypos, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_WHITE,
												"BMP\\TwoDiscLeftStrip.bmp");
	}

	if (0 != m_continuationPanelNumber)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												204, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscRightButton.bmp",
												CCSFSection::BUTTON_JUMPDISCPAGE,
												m_continuationPanelNumber);

		pPanelCSFSection->AddFrameSubSection(	NULL,
												67, ypos + 17, 137, 17,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\ContinuationStrip.bmp");
	}
}

/////////////////////////////////////////////////////////////////////////

CPLOneDisc::CPLOneDisc(const CDisc *pDiscOne)
{
	m_pDiscOne = pDiscOne;
}

CPLOneDisc::~CPLOneDisc(void)
{
}

void CPLOneDisc::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pDiscOne)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												0, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\OneDiscLeftButton.bmp",
												CCSFSection::BUTTON_PLAYDISC,
												m_pDiscOne->GetNum());

		pPanelCSFSection->AddFrameSubSection(	m_pDiscOne->GetTitle(),
												36, ypos + 8, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_WHITE,
												"BMP\\OneDiscStrip.bmp");

		pPanelCSFSection->AddButtonSubSection(	NULL,
												204, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\OneDiscRightButton.bmp",
												CCSFSection::BUTTON_PLAYDISC,
												m_pDiscOne->GetNum());
	}
}

/////////////////////////////////////////////////////////////////////////

CPLTwoDiscs::CPLTwoDiscs(const CDisc *pDiscOne, const CDisc *pDiscTwo)
{
	m_pDiscOne = pDiscOne;
	m_pDiscTwo = pDiscTwo;
}

CPLTwoDiscs::~CPLTwoDiscs(void)
{
}

void CPLTwoDiscs::AddToPanelCSFSection(CCSFSection *pPanelCSFSection, unsigned int ypos) const
{
	if (NULL != m_pDiscOne)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												0, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscLeftButton.bmp",
												CCSFSection::BUTTON_PLAYDISC,
												m_pDiscOne->GetNum());

		pPanelCSFSection->AddFrameSubSection(	m_pDiscOne->GetTitle(),
												36, ypos, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_WHITE,
												"BMP\\TwoDiscLeftStrip.bmp");
	}

	if (NULL != m_pDiscTwo)
	{
		pPanelCSFSection->AddButtonSubSection(	NULL,
												204, ypos, 36, 34,
												CCSFSection::FONT_0,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscRightButton.bmp",
												CCSFSection::BUTTON_PLAYDISC,
												m_pDiscTwo->GetNum());

		pPanelCSFSection->AddFrameSubSection(	m_pDiscTwo->GetTitle(),
												36, ypos + 17, 168, 17,
												CCSFSection::FONT_8,
												CCSFSection::COLOUR_BLACK,
												"BMP\\TwoDiscRightStrip.bmp");
	}
}

/////////////////////////////////////////////////////////////////////////
