
#include "stdafx.h"

#include "SimpleTextFile.h"

/////////////////////////////////////////////////////////////////////////

CSimpleTextFileLine::CSimpleTextFileLine(void)
{
	m_lineBuffer = NULL;
}

CSimpleTextFileLine::~CSimpleTextFileLine(void)
{
	SetLineBuffer(NULL);
}

void CSimpleTextFileLine::SetLineBuffer(const char *buffer)
{
	if (NULL != m_lineBuffer)
	{
		delete [] m_lineBuffer;
		m_lineBuffer = NULL;
	}

	if (NULL != buffer)
	{
		m_lineBuffer = new char[strlen(buffer) + 1];
		strcpy(m_lineBuffer, buffer);
	}
}

const char *CSimpleTextFileLine::GetLineBuffer(void) const
{
	return(m_lineBuffer);
}

/////////////////////////////////////////////////////////////////////////

// This would've been a template class which CCDListFile would've used,
// but I cannot be bothered to learn how to create template types with
// "new". Get errors about there being no default constructor. I guess
// this is what those allocators are for. My lecturers were right, C++
// sucks. Seen it done better! Templates should've been made to work
// like textual substitutions but they don't, which is pathetic.

CSimpleTextFile::CSimpleTextFile(void)
{
}

CSimpleTextFile::~CSimpleTextFile(void)
{
	while (!m_lines.empty())
	{
		delete m_lines.back();
		m_lines.pop_back();
	}
}

bool CSimpleTextFile::Read(FILE *pfInputList)
{
	bool bResult = true;

	// At some point, replace this fixed-size buffer and fgets() with something more intelligent.
	char lineBuffer[BUFFERSIZE];

	char *trimmedLine;
	CSimpleTextFileLine *pLine;

	while (NULL != fgets(lineBuffer, sizeof(lineBuffer), pfInputList))
	{
		trimmedLine = TrimWhitespace(lineBuffer);

		// Ignore empty lines and those starting with "//"
		if ( (0 < strlen(trimmedLine)) && (('/' != trimmedLine[0]) || ('/' != trimmedLine[1])) )
		{
			pLine = new CSimpleTextFileLine();
			pLine->SetLineBuffer(trimmedLine);

			m_lines.push_back(pLine);
		}
	}

	if (bResult && ferror(pfInputList))
	{
		printf("ERROR: Cannot read input file\n");
		bResult = false;
	}

	return(bResult);
}

CSimpleTextFile::lineIterator CSimpleTextFile::lineBegin(void)
{
	return(m_lines.begin());
}

CSimpleTextFile::lineIterator CSimpleTextFile::lineEnd(void)
{
	return(m_lines.end());
}

CSimpleTextFile::const_lineIterator CSimpleTextFile::lineBegin(void) const
{
	return(m_lines.begin());
}

CSimpleTextFile::const_lineIterator CSimpleTextFile::lineEnd(void) const
{
	return(m_lines.end());
}

/////////////////////////////////////////////////////////////////////////
