
#ifndef __SIMPLETEXTFILE_H_
#define __SIMPLETEXTFILE_H_

#pragma warning(disable: 4786)

/////////////////////////////////////////////////////////////////////////

class CSimpleTextFileLine
{
public:
	CSimpleTextFileLine(void);
	virtual ~CSimpleTextFileLine(void);

	void SetLineBuffer(const char *buffer);
	const char *GetLineBuffer(void) const;

private:
	char *m_lineBuffer;
};

/////////////////////////////////////////////////////////////////////////

class CSimpleTextFile
{
public:
	CSimpleTextFile(void);
	virtual ~CSimpleTextFile(void);

	bool Read(FILE *pfInputList);

	typedef list<CSimpleTextFileLine *>::iterator lineIterator;
	typedef list<CSimpleTextFileLine *>::const_iterator const_lineIterator;

	lineIterator lineBegin(void);
	lineIterator lineEnd(void);
	const_lineIterator lineBegin(void) const;
	const_lineIterator lineEnd(void) const;

private:
	list<CSimpleTextFileLine *> m_lines;
};

/////////////////////////////////////////////////////////////////////////

#endif
