
#include "stdafx.h"

#include <math.h>

#include "UnsignedBaseTenNumber.h"

CUnsignedBaseTenNumber::CUnsignedBaseTenNumber(unsigned int number)
{
	m_number = number;

	if (0 == m_number)
	{
		((unsigned int)m_numDigits) = 1;
	}
	else
	{
		((unsigned int)m_numDigits) = 1 + ((unsigned int)floor(log10(m_number)));
	}

	m_asciiRepresentation = new char[m_numDigits + 1];

	stringFormat(m_asciiRepresentation, m_numDigits + 1, "%u", m_number);
}

CUnsignedBaseTenNumber::~CUnsignedBaseTenNumber(void)
{
	if (NULL != m_asciiRepresentation)
	{
		delete [] m_asciiRepresentation;
		m_asciiRepresentation = NULL;
	}
}

unsigned int CUnsignedBaseTenNumber::GetNumberOfDigits(void) const
{
	return(m_numDigits);
}

// Returns zero if digitNumber not in the range [0,NumberOfDigits)
unsigned int CUnsignedBaseTenNumber::GetDigit(unsigned int digitNumber) const
{
	unsigned int result = 0;

	unsigned int numberOfDigits = GetNumberOfDigits();

	if ((0 <= digitNumber) && (digitNumber < numberOfDigits))
	{
		// Converting to ASCII and converting back individual characters is a pretty lame and
		// slow way of doing this, but who cares? :-)

		// Using a table instead of doing "char-'0'" for portability and even more slowness. :-)
		// (Handles the case where the digit isn't a number for some reason, FWIW.)

		// It's Sunday, I'm sick of writing this thing, I just want to use my remote control
		// with CD lists and I don't feel like using my brain. BITE ME! Or, using the wonders
		// of OO, replace this implementation with your fancy one while I listen to my CDs...

		switch(m_asciiRepresentation[digitNumber])
		{
		default:
		case('0'):
			result = 0;
			break;
		case('1'):
			result = 1;
			break;
		case('2'):
			result = 2;
			break;
		case('3'):
			result = 3;
			break;
		case('4'):
			result = 4;
			break;
		case('5'):
			result = 5;
			break;
		case('6'):
			result = 6;
			break;
		case('7'):
			result = 7;
			break;
		case('8'):
			result = 8;
			break;
		case('9'):
			result = 9;
			break;
		}
	}

	return(result);
}

const char *CUnsignedBaseTenNumber::GetAsciiRepresentation(void) const
{
	return(m_asciiRepresentation);
}
