
#ifndef __NUDELGLOBAL_H_
#define __NUDELGLOBAL_H_

// strncpy doesn't always null term the destination... sigh.
// This returns the index of the null terminator.
int stringCopy(char *dest, const char *source, size_t destSize);

// _snprintf doesn't always null term the destination... sigh
// Returns the index of the null terminator.
int stringFormat(char *buffer, size_t bufferSize, const char *format, ...);

// _vsnprintf doesn't always null term the destination... sigh
// Returns the index of the null terminator.
int vStringFormat(char *buffer, size_t bufferSize, const char *format, va_list args);

char *TrimWhitespace(char *buffer);

// pp -- Pointer to buffer to tokenize. Will be advanced to the next position string.
// delimiters -- Characters which delimit the string.
// skipEmpty -- Set true to skip any empty strings. (e.g. someone typed "blah,,blah")
// buf -- Buffer to extract in to. Set to NULL not to extract.
// bufSize -- Size of buf if it is non-NULL. Will truncate string if buf too small.
// Leading and trailing spaces are always stripped.
// Returns false iff nothing could be extracted (i.e. *pp was effectively empty)
// pp and the contents of buf are only valid after calling if true is returns.
// Lame function should allocate us a suitably sized buffer for each string... :-)
// But hey, this isn't a public OS function and you can just give a buffer the size of the input...
bool TokenizeEx(const char **pp, const char *delimiters, char *buf, size_t bufSize, bool skipEmpty);

// returns NULL on failure
// delete[] the result when you are finished with it.
char *getFileVersion(void);

// If this returns '\0' there was no alpha-numeric letter.
char getFirstInterestingLetter(const char *string);

#endif
